local MAJOR, MINOR = "MyLibrary-1.0", 1
local lib = VOLibStub:NewLibrary(MAJOR, MINOR) --returns nil if already loaded, otherwise returns a table

if (not lib) then return end --if nil, there's nothing that needs to be done

lib.embeds = lib.embeds or {}

function lib:Lib1FuncA()
	test.print(MAJOR..'.'..MINOR..' - Executing Lib1FuncA()')
end

function lib:Lib1FuncB()
	test.print(MAJOR..'.'..MINOR..' - Executing Lib1FuncB()')
end

local mixins = {"Lib1FuncA", "Lib1FuncB"} -- list of functions to be embedded

function lib:Embed(target)
	for _,name in pairs(mixins) do
		target[name] = lib[name]
	end
	lib.embeds[target] = true
end

-- Put this at the very end of the library to automatically update all functions
for target,_ in pairs(lib.embeds) do
	lib:Embed(target)
end