local MAJOR, MINOR = "MyLibrary-2.0", 2
local lib = VOLibStub:NewLibrary(MAJOR, MINOR) --returns nil if already loaded, otherwise returns a table

if (not lib) then return end --if nil, there's nothing that needs to be done

lib.embeds = lib.embeds or {}

function lib:Lib2FuncA()
	test.print(MAJOR..'.'..MINOR..' - Executing Lib2FuncA()')
end

function lib:Lib2FuncB()
	test.print(MAJOR..'.'..MINOR..' - Executing Lib2FuncB()')
end

local mixins = {"Lib2FuncA", "Lib2FuncB"} -- list of functions to be embedded

function lib:Embed(target)
	for _,name in pairs(mixins) do
		target[name] = lib[name]
	end
	lib.embeds[target] = true
end

-- Put this at the very end of the library to automatically update all functions
for target,_ in pairs(lib.embeds) do
	lib:Embed(target)
end