-- LibStub is a simple versioning stub meant for use in Libraries.  http://www.wowace.com/wiki/LibStub for more info
-- LibStub is hereby placed in the Public Domain Credits: Kaelten, Cladhaire, ckknight, Mikk, Ammo, Nevcairiel, joshborke

-- LibStub for Vendetta Online was forked from LibStub minor version 2, due to differences in the API
-- LibStub fork for Vendetta Online: draugath


local LIBSTUB_MAJOR, LIBSTUB_MINOR = "VOLibStub", 2  -- NEVER MAKE THIS AN SVN REVISION! IT NEEDS TO BE USABLE IN ALL REPOS!
local LibStub = loadstring('return '..LIBSTUB_MAJOR)()

if not LibStub or LibStub.minor < LIBSTUB_MINOR then
	LibStub = LibStub or {libs = {}, minors = {} }
	declare(LIBSTUB_MAJOR, LibStub)
	LibStub.minor = LIBSTUB_MINOR
	
	function LibStub:NewLibrary(major, minor)
		assert(type(major) == "string", "Bad argument #2 to 'NewLibrary' (string expected, got "..type(major)..")")
		assert(type(minor) == "number" or
		       type(minor) == "string", "Bad argument #3 to 'NewLibrary' (number or string expected, got "..type(minor)..")")
		minor = assert(tonumber(string.match(minor, "%d+")), "Minor version must either be a number or contain a number.")
		
		local oldminor = self.minors[major]
		if oldminor and oldminor >= minor then return nil end
		self.minors[major], self.libs[major] = minor, self.libs[major] or {}
		return self.libs[major], oldminor
	end
	
	function LibStub:GetLibrary(major, silent)
		if not self.libs[major] and not silent then
			error(("Cannot find a library instance of %q."):format(tostring(major)), 2)
		end
		return self.libs[major], self.minors[major]
	end
	
	function LibStub:IterateLibraries() return pairs(self.libs) end

	function LibStub:PLUGINS_LOADED(event) ProcessEvent("LIBRARIES_LOADED") end
	RegisterEvent(LibStub, "PLUGINS_LOADED")
end
